/*
	$Header: /home/itig/cvsroot/ext2ifs/src/devctrl.c,v 1.1 2000/10/26 11:33:49 jn Exp $
*/

#include "ext2fs.h"

NTSTATUS
XtDeviceControl (
    IN PFSD_IRP_CONTEXT IrpContext
	)
{
    PDEVICE_OBJECT  DeviceObject;
    NTSTATUS        Status = STATUS_UNSUCCESSFUL;
    PVCB			Vcb;
    PIRP            Irp;
    PIO_STACK_LOCATION IrpSp;
    PIO_STACK_LOCATION NextIrpSp;

    ASSERT(IrpContext != NULL);

/*        ASSERT((IrpContext->Identifier.Type == ICX) &&
           (IrpContext->Identifier.Size == sizeof(FSD_IRP_CONTEXT)));*/

    DeviceObject = IrpContext->DeviceObject;

    //
    // This request is not allowed on the main device object
    //
    if (DeviceObject == Global->DeviceObject)
    {
        Status = STATUS_NOT_IMPLEMENTED;
        IrpContext->Irp->IoStatus.Status = Status;
		XtFSCompleteRequest(IrpContext, IO_NO_INCREMENT);
    }
	else
    {
        Vcb = (PVCB) DeviceObject->DeviceExtension;

		ASSERT(Vcb != NULL);

		Irp = IrpContext->Irp;

		IrpSp = IoGetCurrentIrpStackLocation(Irp);
	    NextIrpSp = IoGetNextIrpStackLocation(Irp);
	    *NextIrpSp = *IrpSp;

		//IoSkipCurrentIrpStackLocation(Irp);

		IrpContext->Completed = TRUE;
		Status = IoCallDriver(Vcb->TargetDeviceObject, Irp);
    }

    return Status;
}
